# Workbench API

The Workbench v3 API provides general endpoints for the WBC 3.0 (`/v3`), provides access to frontend resources for WBC iframes (`/v3/frontends`) and allows App UIs to access medical data through the Workbench v3 Scopes API (`/v3/scopes`). This documentation only refers to the Scopes API as it is the only part of the API relevant for app development.

Structure of the Workbench API:

* `/v3` (Workbench API)
  * Retrieve clinical data like cases, examinations and slides
* `/v3/frontends`
  * Endpoint to load an App UI within the Workbench Client
* `/v3/scopes` (Scopes API)
  * Retrieve slides and associated slide data valid for the selected case
  * Retrieve jobs and data already existing in this examination and scope
  * Post new data (e.g. annotations, classes, primitives, etc.)
  * Create and execute jobs for the associated app
  * Retrieve result data produced by jobs (e.g. annotations, classes, primitives, etc.)
  * **THIS IS THE ONLY RELEVANT API** for your App UI to interact with

## Scopes API

Through the Scopes API an App UI can create and retrieve medical data in the EMPAIA Platform. For example an App UI may query Slides and the corresponding image tiles to be rendered in a web viewer. It also allows for running the associated app in the platform backend by assembling a job with certain input data (e.g. a RoI annotation drawn on a WSI). When the app processing is completed, the output data can be queried and displayed to the user. API access is **always** bound to a **Scope** to prevent accessing data, that is not contained in the given case or not created in the context of the selected app. A Scope has its own ID and is uniquely tied to the combination of user ID and examination ID, where the examination ID implies a specific case ID and app ID. However, it is not tied to a certain browser session. Instead, if a user opens the same examination and app in another browser session, the same Scope ID is provided to the App UI. An examination is itself tied to a case, therefore only the data of the given case (e.g. list of slides) can be retrieved from a Scope. An App UI must always send a valid Scope ID and Scope Token to authorize requests.

## OpenAPI Specification

<a href="specs/wbs_v3_scopes_redoc" target="_blank">OpenAPI specification in Redoc</a>

For additional information on how to connect an App UI to the Scopes API, please refer to the [Tutorial: Frontend](tutorial_frontend/tutorial.md#) section.

The following sections list and explain certain key concepts of the Scopes API. These sections follow the same structure as the OpenAPI Specification.

## General Remarks

As described above, a Scope is the composition of an `examination_id`, an `app_id` and the `user_id`. To authorize against the Scopes API you will need a `scope_id` and have to set a valid `scope_token` in the request headers. This is required for every API-call.

```
Authorization: Bearer {scope_token}
```

!> The `scope_id` and `scope_token` **MUST** belong to the same Scope, otherwise your request will be rejected. For all POST data the `creator_id` **MUST** be the `scope_id` and `creator_type` **MUST** be `"scope"`

For information on how to retrieve the `scope_id` and `scope_token` see [Tutorial: Frontend](tutorial_frontend/scope_token.md#)

## Scope

* These endpoints allow your app to access the scope of the current user and all scopes of the current examination.

### Retrieve Scope of current user

Via the `/{scope_id}` endpoint all relevant Scope information of the current user can be retrieved (e.g., `examination_id`, `app_id`, `user_id`, and `ead`). Additionally, the state of the examination (`OPEN` or `CLOSED`) is included in the property `examination_state`. A closed examination is in a read only mode, which means that no new data (e.g. user created annotations, new jobs) can be persisted. An App UI can use this state to restrict user interactions accordingly.

### Retrieve all Scopes of current examination

The `/{scope_id}/scopes` endpoint provides a count and list of all scopes within the current examination. The scopes itself contain the id for each scope. These ids can be used in all data queries as value for the `creators` filter (see [Queries](specs/workbench_api.md#queries)) to access data generated by other users in the same examination.

This is a feature extension for the Workbench v3 API as described in [EMP-0104](https://gitlab.com/empaia/emps/-/blob/main/emp-0104.md).

## Jobs

* These endpoints allow your app to create new jobs and to retrieve already existing ones.

### Containerized Jobs

`standalone` or `postprocessing` jobs, whereas the later can also be  `"containerized": False`. The required workflow to successfully create and run containerized jobs is as follows:

1. Create a new job (`POST`) including in the POST data
   * Either `"mode": "standalone", "containerized": False`
   * Or `"mode": "postprocessing", "containerized": False`
2. Retrieve existing data or create new data as input
   1. WSIs must be selected from an underlying case via [Slides](specs/workbench_api.md#slides)
   2. All other inputs (RoIs / Annotations, Classes, Primitives, Collections) must
     * Either be created (`POST` endpoints from [Data](specs/workbench_api.md#data))
     * Or be selected from previous jobs (see also [Data](specs/workbench_api.md#data))
3. Required job inputs declared in the EAD must be added with their `id` to the job (`PUT /jobs/{job_id}/input/{input_key}`)
   1. `input_key` **MUST** match the input of the EAD
   2. Posted input type **MUST** match `type` declared in the EAD
4. Exucute the job (`PUT /jobs/{job_id}/run`)
   1. All job inputs and class constraints declared in the EAD are validated
   2. All inputs are **locked** for the current `job_id` (the concept of **locking** is explained in [Locking](specs/workbench_api.md#data-locking))
   3. The job is scheduled for execution
5. Periodically request the job to check the current status
6. When job execution has finished
   1. Request all job data (inputs and / or results) via endpoints from [Data](specs/workbench_api.md#data)

!> Once a job is started it can't be modified or deleted.

### Non-Containerized Jobs

Reports or postprocessing jobs (if specified with `"containerized": False` in the EAD).
Non-containerized jobs postprocessing jobs, typically do not induce heavy workload, and can therefore be executed by the App UI, e.g. a user corrects false classification results of a standalone or preprocessing job.

The required workflow to successfully create and run non-containerized jobs is as follows:

1. see [Containerized Jobs](specs/workbench_api.md#containerized-jobs)
2. see [Containerized Jobs](specs/workbench_api.md#containerized-jobs)
3. see [Containerized Jobs](specs/workbench_api.md#containerized-jobs)
4. Outputs are now added to the job by the App UI the same way inputs are added via `PUT /jobs/{job_id}/outputs/{output_key}`
5. Instead of using the `/run` endpoint, use `PUT /jobs/{job_id}/finalize`, when the job needs to become immutable

* **NOTE:** Reports cannot be finalized. This is done by the Workbench itself, when an examination is closed and made immutable.

!> As Reports cannot be finalized we suggest that your App UI constantly updates the report job, when new results are available. Also, there can only be one report job per scope.

## Slides

Via the `GET /slides` endpoint an App UI has access to all slides assigned to the underlying Case.

For the properties `tissue` and `stain` the information in `mappings` can be used to display translated clinical information for each slide.

For more information regarding slide data (metadata and image data) see [WSI Data](specs/wsi_data.md#)

## Storage

If your App UI needs to save (or store) data not related to jobs, the storage endpoints should be used. This feature can be used to persist UI configurations or user/scope settings.
There are two types of storages:

1. `/{scope_id}/app-ui-storage/scope`
    * Flat JSON key value pairs
    * Shared storage for the current scope
2. `/{scope_id}/app-ui-storage/user`
    * Flat JSON key value pairs
    * Shared storage for the current user (for each app) across scopes

## Data

The data endpoints enable an App UI to create input data for jobs and to retrieve all required job data in order to visualize the results of jobs after completion.

### Data Creation

For information about the creation of data refer to the Data `POST` endpoints of the <a href="specs/wbs_v3_scopes_redoc" target="_blank">OpenAPI specification</a>

!> All `POST` endpoints in the Data have the query parameter `external_ids`. This parameter is used in the EATS for testing purposes. In **ALL** deployments of the EMPAIA Platform external IDs will **ALWAYS** be disabled! Your app **MUST NOT** depend on the possibility to post externally generated IDs! All IDs in posted data will be **IGNORED**!

#### Annotations and Class constraints

If an EAD defines a class constraint, a valid class must be created for each affected annotation. This can be done using the `POST /class` endpoint. An exception is the global class RoI (class value `org.empaia.global.v1.classes.roi`), that can not be created through the `POST /classes` endpoint. RoI classes **MUST** be created with the query parameter `is_roi=true` in the `POST` annotation endpoint. When doing so, for each annotation a class with the value `org.empaia.global.v1.classes.roi` and a correct reference is created.

#### Annotations and Centroids

Annotations can be created with an optional `centroid`. If no `centroid` is given, it will be calculated during `POST`.

A posted `centroid` will **NOT** be checked!

For more information about the function of centroids see [Annotation Queries](specs/workbench_api.md#annotation-queries).

#### Annotations and Resolution

Posted annotations **MUST** contain the property `npp_created` indicating the resolution in nanometers per pixel on which the annotation was created.

Annotations can also contain the property `npp_viewing`. For more information see [Annotation Resolution](specs/annotation_resolution.md#).

#### Collections and Collection Items

Collections can be created or extended in different ways:

1. Post a new collection with new items in a single request
2. Post a new empty collection and add new items in one or more separate requests using the `POST /collections/{collection_id}/items` endpoint
3. Post a new collection with previously created items in a single request
4. Post a new empty collection and add previously created items in one or more separate requests using the `POST /collections/{collection_id}/items` endpoint

!> The `item_type` of the collection and type of items posted together with the collection or added afterwards **MUST** always match!

If previously created items are posted (together with a collection or added after creation), each item **MUST** be formatted as `{"id": id}`, where `id` is the returned `id` of a previously created data element. New items and previously created items can not be mixed in a single request.

Items can always be added to collections no matter how the collection was created (empty or with items).

### Data Locking

Data Locking is a key concept to link all relevant data to a specific job. The process of locking is performed in two steps (only the first step is done by the App UI):

1. Input data is locked when an App UI calls the endpoint to execute a job
2. Output data is locked when an app calls the finalize endpoint

The Medical Data Service will persist a lock as a tuple of the item ID and job ID.

Locked data can be reused, e.g. an annotation can be input for multiple jobs.

Collections are locked recursively, i.e. all containing items are locked as well. Created classes that are defined as class contraints in the EAD are locked when the annotation, the class refers to, is locked.

!> Locked data can't be modified or deleted.

### Data Retrieval

For information about the retrieval of data refer to the Data `GET` and `PUT /query` endpoints of the <a href="specs/wbs_v3_scopes_redoc" target="_blank">OpenAPI specification</a>

All `GET` and `PUT /query` endpoints can be used with the query parameters `skip` and `limit`. These parameters enable a batchwise retrieval of the data and thus provide the functionality to implement pagination for data visualization. All responses are sorted by creation time in descending order.

Using `skip` or `limit` doesn't influence the `item_count`. `item_count` always indicate the number of items that match the filter criteria.

#### Queries

Data can be queried by using the `PUT /query` endpoints. A query is semantically a filter to indicate what properties the returned data must have. The general form of all data queries is:

```JSON
{
   "creators": [...],
   "references": [...],
   "jobs": [...]
}
```

* `"creators"` is a list of `creator_id`s: filter data by creator (**MUST** be a list of valid `scope_id`s from within the current examination; the list can contain a single `scope_id` if data of a single Scope should be returned)
* `"references"` is a list of `reference_id`s: filter data by their reference (e.g. a single `slide_id` to retrieve all annotations for that slide)
* `"jobs"` is a list of `job_id`s: filter data by the jobs it was locked for (e.g. a single `job_id` to retrieve all data for that job; inputs **AND** outputs)

!> **IMPORTANT API CHANGE**: As of EATS Version 3.6.1 data queries accept all `scope_id`s from within the current examination as values for the `"creators"` filter! Previously, only the current `scope_id` was a valid value.
To retieve a list of all Scopes of the the current examination see [Retrive all Scopes of currents examination](specs/workbench_api.md#retrieve-all-scopes-of-current-examination)

!> For `jobs` only `job_id`s within the current examination are allowed!

A filter **MUST** contain at least one value. If you don't want to use a certain filter, the property **MUST** be ommitted. The values for one filter are logically connected by **OR**, the different filters by **AND**. Each additional filter will always maintain or reduce the number of matching items, never increase it.

For some data types additional filters are available or additional values are allowed!

#### Primitive Queries

Primitive queries allow an additional filter:

* `"primitives"` is a list of primitive `id`s to filter primitives by ID

Primitives don't require a reference, therefore `references` can contain `null` to include primitives without references.

#### Collection Queries

!> **IMPORTANT API CHANGE:** As of EATS Version 3.4.3 collection queries are **no longer supported**. It is still included in the API but the reference implementation of the Medical Data Service will respond with the HTTP status code `501`.

#### Collection Items Queries

The items of collections can be queried as well. The available query filters are:

```JSON
{
   "references": [...],
   "viewport": {"x": int, "y": int, "width": int, "height": int},
   "npp_viewing": [int, int]
}
```

The filters `"viewport"` and `"npp_viewing"` are only considered if the item type of the collection is an annotation type (`"point"`, `"line"`, `"arrow"`, `"circle"`, `"rectangle"` or `"polygon"`) and ignored otherwise.

#### Class Queries

Class queries allow an additional filter:

* `"classes"` is a list of class `id`s to filter classes by ID

Class queries can be sent with the additional query parameter `with_unique_class_values=true` to include a list of all unique class values in the response.

The usage of `skip` or `limit` does not influence the values for `unique_class_values`.

If you are only interested in the list of unique class values, you can set `limit=0`.

#### Annotation Queries

Annotation queries allow additional filters:

* `"types"` is a list of annotation types to filter annotations by type (e.g. `point` or `polygon`)
* `"viewport"` is a JSON dictionary (`{"x": int, "y": int, "width": int, "height": int}`) and filters annotations by location
  * Every annotation within the given region (incl. intersections) is returned
  * **REMARK:** An annotation is returned, if its bounding box overlaps with the viewport (bounding boxes for annotations are created and persisted automatically during a `POST`)
* `"npp_viewing"` is a tuple of lower and upper resolutions in npp (nanomater per pixel) to filter annotations by creation or viewing resolution (for more information see [Annotation Resolution](specs/annotation_resolution.md#))
* `"class_values"` is a list of class values to filter annotations by the values of classes referencing them
* `"annotations"` is a list of annotation `id`s to filter annotations by ID (for an example why this could be useful see [Annotation Viewer Query](specs/workbench_api.md#annotation-viewer-query))

!> **IMPORTANT API CHANGE:** Until EATS Version 3.2.2 `"class_values"` could contain `null` if annotations without classes should be included. As of EATS Version 3.3.0 `null` is **no longer supported** as value for `"class_values"`. It is still included in the API but the reference implementation of the Medical Data Service will respond with the HTTP status code `422`.

!> **IMPORTANT API CHANGE:** Until EATS Version 3.2.2 `"jobs"` could be `[null]` if annotations not locked for any job should be returned. As of EATS Version 3.3.0 `[null]` is **no longer supported** as value for `"jobs"`. It is still included in the API but the reference implementation of the Medical Data Service will respond with the HTTP status code `422`.

Annotation queries also allow additional query parameter:

* `with_classes=true` include classes referencing each returned annotation. The classes are included as a list for the property `classes`. If an annotation has no class, `classes` is an empty list
* `with_low_npp_centroids=true` includes a list of centroids in the response. The centroids can be used in a viewer to signal the user the presence of annotations that would become visible by zooming further into that region of the slide. The list contains all annotations as a centroid representation, that
  * match the filter criteria except `npp_viewing`
  * the range / values for `npp_viewing` or `npp_created` of the annotations are lower than the `npp_viewing` range from the query (for further information see [Annotation Resolution](specs/annotation_resolution.md#))

?> The query parameter `with_low_npp_centroids` can only be used if `"npp_viewing"` is used as a filter.

#### Annotation Viewer Query

The endpoint `PUT /annotations/query/viewer` is a special flavor of the general annotations query endpoint. The filters are equal (except `annotations`) and there are no query parameters. The response always contains IDs of all annotations matching the filter criteria and centroids. The returned IDs can then be used as filter for the general query. This procedure, which at first glance seems cumbersome, allows annotations to be cached by their IDs to only request new annotations in a second API-call. Depending on the number of annotations this could result in a significant performance improvement.

!> Both queries **MUST** use the same filters except `annotations` (only in the general annotations query) if you want to use the described method for annotation caching.

#### Annotation Count Query

A convenience endpoint to only retrieve the count of matching annotations.

The same effect can be achieved if `limit=0` is used in the general annotations query. The general query can be noticeably slower than the special count query.

#### Annotation Unique Class Values Query

This endpoint returns a list of unique class values for annotations matching filter criteria.

Result may contain `null` if annotations without assigned classes matching the filter criteria.

#### Annotation Query Position

Assuming you visualize all annotations for a slide in a slide viewer and a paginated subset of n related slide items in a list beside the viewer. If the user clicks on an annotation in the viewer the list should update to show the relevant subset that includes the clicked annotation. With the annotation query position endpoint you can retrieve the position of an annotation in the response property `items` list of a general annotations query. With the position you are able to set `skip` and `limit` accordingly and retrieve the relevant subset to update your list.

!> The filter for all involved queries **MUST** be identical.

#### Unique References Queries

These endpoints return all unique reference IDs of the items matching the filter criteria. The IDs are grouped by the reference types `annotation`, `collection` and `wsi`. Collections and Primitives include the optional property `contains_items_without_reference` to indicate if there are matching items without a reference.

### Modify and Delete Data

Only data that is **NOT** locked can be modified or deleted.

If a collection is deleted, the items are **NOT** deleted recursively

!> All **Inputs** and **Outputs** of started Jobs are **immutable**.

### Pixelmaps

[Pixelmaps](glossary.md#pixelmap) are fully defined in [EMP-0102](https://gitlab.com/empaia/emps/-/blob/main/emp-0102.md).

#### Requesting Pixelmaps Level and Resolution Info

Under certain circumstances it might not be possible to access level and resolution information of a referenced WSI via the `GET /{scope_id}/slides/{slide_id}/info` endpoint. In these cases see [Pixelmaps Level and Resolution Info](specs/pixelmap_resolution.md#)

#### Pixelmaps Tile Transfer Compression

For optional Pixelmaps Tile Transfer Compression see [Pixelmaps Tile Transfer Compression](specs/pixelmap_tile_compression.md#)
